## emelfm2 0.3.5

=== Makefile ===
# $Id: Makefile 560 2007-07-24 12:46:09Z tpgww $
#
# Copyright (C) 2003-2007 tooar <tooar@gmx.net>
#
# This file is part of emelFM2.
# emelFM2 is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# emelFM2 is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with emelFM2; see the file GPL. If not, contact the Free Software
# Foundation, 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

# This is the Makefile of emelFM2. You should not change it!
# Edit the file Makefile.config to change build options.

# include user configuration
include Makefile.config

# this is effectively obsolete
ICON_SIZE = 48

# internal configuration
DIRS = src src/actions src/build src/command src/command/complete src/config \
       src/dialogs src/filesystem src/utils
LIBS = plugins
OPTLIBS = optional
ICONS = icons
OBJECTS_DIR = objs

TARGET = emelfm2

MARSHALS_PREFIX = e2_marshal
MARSHALS_LIST = src/build/$(MARSHALS_PREFIX).list
MARSHALS_HEADER = src/build/$(MARSHALS_PREFIX).h
MARSHALS_BODY = src/build/$(MARSHALS_PREFIX).c

API_DOC_DIR = docs/api

# build info for build.h
VERSION=0.3.5
#this is effectively a sub-version, to manage config file upgrades while not changing the version
RELEASE=
#RELEASE=.1
PROGNAME=emelFM2
BUILDDATE=$(shell date)
BUILDSTAMP=$(shell date +"%02d %b %04Y")
BUILDINFO=$(shell uname) $(shell uname -r)/$(shell uname -m)
COPYRIGHT=2003-$(shell date +"%04Y"), tooar <tooar@gmx.net>

#these are only used here for installation purposes
BIN_DIR = $(PREFIX)/bin
MAN_DIR = $(PREFIX)/share/man/man1
#as well as usage here, all in-code uses of these is assumed localised
ifeq ($(DOCS_VERSION), 1)
DOC_DIR = $(PREFIX)/share/doc/$(TARGET)-$(VERSION)
else
DOC_DIR = $(PREFIX)/share/doc/$(TARGET)
endif
#FIXME By default, apps should look for icons in $XDG_DATA_DIRS/icons and in /usr/share/pixmaps (in that order).
ICON_DIR = $(PREFIX)/share/pixmaps/$(TARGET)
LOCALE_DIR = $(PREFIX)/share/locale
PLUGINS_DIR = $(PREFIX)/lib/$(TARGET)/$(LIBS)

# optional plugins (and related icons, below)
PLUGFILEPREFIX=e2p_
ICONFILEPREFIX=plugin_
BASENAME1:=thumbs
BASENAME2:=track
BASENAME3:=acl
LIBS_XSOURCES=
LIBS_XHEADERS=
# when doing make install, make i18n etc don't want to have to supply optional plugin parameters
ifeq ($(WITH_THUMBS),0)
WITH_THUMBS:=$(shell test -f $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME1).so && echo "1" || echo "0" 2>&1)
endif
ifeq ($(WITH_TRACKER),0)
WITH_TRACKER:=$(shell test -f $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME2).so && echo "1" || echo "0" 2>&1)
endif
ifeq ($(WITH_ACL),0)
WITH_ACL:=$(shell test -f $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3).so && echo "1" || echo "0" 2>&1)
endif

ifeq ($(WITH_THUMBS),1)
LIBS_XSOURCES += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME1)*.c)
LIBS_XHEADERS += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME1)*.h)
endif
ifeq ($(WITH_TRACKER),1)
LIBS_XSOURCES += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME2)*.c)
LIBS_XHEADERS += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME2)*.h)
endif
ifeq ($(WITH_ACL),1)
LIBS_XSOURCES += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3)*.c)
LIBS_XHEADERS += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3)*.h)
endif

# object directories that have to be created
MKOBJDIRS = $(foreach dir, $(DIRS) $(LIBS), $(OBJECTS_DIR)/$(dir)) $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)

SOURCES = $(foreach dir, $(DIRS), $(wildcard $(dir)/*.c))
HEADERS = $(foreach dir, $(DIRS), $(wildcard $(dir)/*.h))
OBJECTS = $(SOURCES:%.c=$(OBJECTS_DIR)/%.o)

LIBS_SOURCES = $(foreach dir, $(LIBS), $(wildcard $(dir)/*.c)) $(LIBS_XSOURCES)
LIBS_HEADERS = $(foreach dir, $(LIBS), $(wildcard $(dir)/*.h)) $(LIBS_XHEADERS)
# this includes none of any optional extra plugins, workaround provided below
LIBS_OBJECTS = $(LIBS_SOURCES:%.c=$(OBJECTS_DIR)/%.so)

DEP_FILES = $(SOURCES:%.c=$(OBJECTS_DIR)/%.deps)
LIBS_DEP_FILES = $(LIBS_SOURCES:%.c=$(OBJECTS_DIR)/%.deps)

PO_DIR = po
PO = $(wildcard $(PO_DIR)/*.po)
MO = $(PO:%.po=%.mo)

BUILD_FILE = src/build/build.h

# local include directories
LINC = $(foreach dir, $(DIRS), -I$(dir))
lCFLAGS = $(CFLAGS)

#these are redundant now
#lCFLAGS += -DGTK_DISABLE_DEPRECATED
#lCFLAGS += -DGDK_DISABLE_DEPRECATED
#lCFLAGS += -DG_DISABLE_DEPRECATED

# set up debugging
ifeq ($(DEBUG), 0)
# this default level omits all warning-message code
DEBUG_LEVEL ?= 2
else
#this is the highest level
DEBUG_LEVEL ?= 5
lCFLAGS += -g -O0
endif

#gamin code is a superset of FAM code, so gamin needs fam as well
ifeq ($(USE_GAMIN), 1)
USE_FAM = 1
endif
#FAM & gamin prevail over specific kernel monitoring
ifeq ($(USE_FAM),1)
WITH_KERNELFAM = 0
USE_INOTIFY = 0
USE_DNOTIFY = 0
endif
ifeq ($(USE_DNOTIFY),1)
WITH_KERNELFAM = 1
USE_INOTIFY = 0
else
ifeq ($(WITH_KERNELFAM),1)
WITH_KERNELFAM = 1
USE_INOTIFY = 1
endif
endif

#kernel-based monitoring also needs some of the fam code
#but we have to handle that below, to prevent incorrect lLDFLAGS

#other conditional defines set in $(BUILD_FILE) - see below

# set up i18n
BIN_XGETTEXT = $(shell which xgettext 2>/dev/null)
ifeq ($(BIN_XGETTEXT), "")
I18N = 0
endif
BIN_MSGFMT = $(shell which msgfmt 2>/dev/null)
ifeq ($(BIN_MSGFMT), "")
I18N = 0
endif
BIN_MSGMERGE = $(shell which msgmerge 2>/dev/null)
ifeq ($(BIN_MSGMERGE), "")
I18N = 0
endif
ifeq ($(I18N), 1)
lCFLAGS += -DENABLE_NLS
endif

# set up flags
# overflow protection with gcc4
#lCFLAGS += -D_FORTIFY_SOURCE
lCFLAGS += -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_REENTRANT -I. $(LINC)
ifeq ($(EDITOR_SPELLCHECK),1)
lCFLAGS += $(shell pkg-config --cflags gtk+-2.0 gthread-2.0 gtkspell-2.0)
else
lCFLAGS += $(shell pkg-config --cflags gtk+-2.0 gthread-2.0)
endif
ifeq ($(WITH_THUMBS),1)
lCFLAGS += $(shell pkg-config --cflags gimpthumb-2.0)
endif
#for gvfs development
ifeq ($(WITH_GVFS),1)
lCFLAGS += $(shell pkg-config --cflags gio-standalone)
endif

lLIBS_CFLAGS += -shared -fPIC -DPIC

lLDFLAGS = $(LDFLAGS)
# -lrt needed for clock_gettime()
lLIBS = $(shell pkg-config --libs gtk+-2.0 gthread-2.0 gmodule-2.0) -lrt
ifeq ($(USE_FAM),1)
lLIBS += -lfam
endif
ifeq ($(EDITOR_SPELLCHECK),1)
lLIBS += -lgtkspell
endif
ifeq ($(WITH_THUMBS),1)
lLIBS += $(shell pkg-config --libs gimpthumb-2.0)
endif
ifeq ($(WITH_TRACKER),1)
#	lLIBS += $(shell pkg-config --libs ??)
endif
ifeq ($(WITH_ACL),1)
lLIBS += -lacl
endif
# should not need translation
OPSYS := $(shell uname)
ifeq ($(OPSYS),FreeBSD)
OSREL = $(shell sysctl -n kern.osreldate)
lLIBS += $(shell if test $(OSREL) -lt 500041 ; then echo "-lgnugetopt"; fi)
endif

#for gvfs development
ifeq ($(WITH_GVFS),1)
lLIBS += $(shell pkg-config --libs gio-standalone)
endif

.PHONY: all plugins install install_plugins uninstall uninstall_plugins doc \
        clean deps marshals gettext i18n install_i18n uninstall_i18n \
		test test2 help

# targets
all: $(OBJECTS_DIR) $(BUILD_FILE) $(TARGET) $(LIBS)

plugins: $(OBJECTS_DIR) $(LIBS_OBJECTS)

install: all install_plugins
	@echo "installing $(TARGET) to prefix '$(PREFIX)'"
	@install -d -m 755 $(BIN_DIR)
	@install -m 755 $(TARGET) $(BIN_DIR)
	@install -d $(ICON_DIR)
	@for file in `ls icons/ |grep -v svn`; do \
		install -m 644 icons/$$file $(ICON_DIR); \
	done
	@install -d $(DOC_DIR)
	@for file in `ls docs/ |grep -v svn |grep -v desktop_environment |grep -v api |grep -v $(TARGET).1`; do \
		install -m 644 docs/$$file $(DOC_DIR); \
	done
	@install -d $(MAN_DIR)
	@install -m 644 docs/$(TARGET).1 $(MAN_DIR);
	@bzip2 -f $(MAN_DIR)/$(TARGET).1;

ifeq ($(XDG_INTEGRATION), 1)
		@install -d $(XDG_DESKTOP_DIR)
		@install -m 644 docs/desktop_environment/$(TARGET).desktop \
			$(XDG_DESKTOP_DIR)
		@install -d $(XDG_APPLICATION_DIR)
		@install -m 644 docs/desktop_environment/$(TARGET).applications \
			$(XDG_APPLICATION_DIR)
endif

install_plugins: plugins
	@echo "installing plugins to prefix '$(PREFIX)'"
	@install -d $(PLUGINS_DIR)
	@for file in "$(LIBS_OBJECTS)"; do \
		install -c -m 755 $$file $(PLUGINS_DIR); \
	done
	@for file in $$(ls -x $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)/*.so); do \
		install -c -m 755 $$file $(PLUGINS_DIR); \
	done
	@install -d $(ICON_DIR)
ifeq ($(WITH_THUMBS),1)
	@install -c -m 644 $(LIBS)/$(OPTLIBS)/$(ICONFILEPREFIX)$(BASENAME1)_$(ICON_SIZE).png $(ICON_DIR);
endif
ifeq ($(WITH_TRACKER),1)
	@install -c -m 644 $(LIBS)/$(OPTLIBS)/$(ICONFILEPREFIX)$(BASENAME2)_$(ICON_SIZE).png $(ICON_DIR);
endif
ifeq ($(WITH_ACL),1)
	@install -c -m 644 $(LIBS)/$(OPTLIBS)/$(ICONFILEPREFIX)$(BASENAME3)_$(ICON_SIZE).png $(ICON_DIR);
endif

uninstall: uninstall_plugins
	@echo "uninstalling $(TARGET) from prefix '$(PREFIX)'"
	@rm -f $(BIN_DIR)/$(TARGET)
	@rm -rfd $(DOC_DIR)
#	@echo -e "\nif you like you can also delete the icon directory:\n\t$(ICON_DIR)\n"
	@rm -rfd $(ICON_DIR)
	@rm -f $(MAN_DIR)/$(TARGET).1.bz2;

uninstall_plugins:
	@echo "uninstalling plugins from '$(PREFIX)'"
	@test -d "$(PLUGINS_DIR)" && rm -rfd $(PLUGINS_DIR)
	@test -d "$(PREFIX)/lib/$(TARGET)" && rm -rfd $(PREFIX)/lib/$(TARGET)

doc:
	@echo -n "generating api documentation in '$(API_DOC_DIR)'"
	@rm -rfd $(API_DOC_DIR)
	@doxygen >/dev/null
	@echo

clean:
	@echo "cleaning up"
	@rm -f $(TARGET)
	@rm -f $(BUILD_FILE)
	@rm -f $(MARSHALS_BODY)
	@rm -f $(MARSHALS_HEADER)
	@rm -f *.bak
	@rm -f $(PO_DIR)/*.mo
	@rm -rfd $(OBJECTS_DIR)
	@rm -rfd $(API_DOC_DIR)

$(TARGET): $(OBJECTS)
	@echo "linking binary '$(TARGET)'"
	@$(CC) $(lCFLAGS) $(lLDFLAGS) $(OBJECTS) $(lLIBS) -o $(TARGET)
ifneq ($(DEBUG), 1)
	@echo "stripping binary '$(TARGET)'"
	@strip $(TARGET)
endif

$(OBJECTS): $(OBJECTS_DIR)/%.o: %.c
	@echo "compiling '$*.c'"
	@$(CC) $(lCFLAGS) -c -o $@ $*.c

$(LIBS_OBJECTS): $(OBJECTS_DIR)/%.so: %.c
	@echo "compiling '$*.c'"
	@$(CC) $(lCFLAGS) $(lLIBS_CFLAGS) -o $@ $*.c

deps: $(DEP_FILES) $(LIB_DEP_FILES)
$(DEP_FILES): $(OBJECTS_DIR)
$(DEP_FILES): $(BUILD_FILE)
$(DEP_FILES): $(OBJECTS_DIR)/%.deps: %.c
	@echo "generating '$@'"
	@$(CC) $(lCFLAGS) -MM -o $@ $*.c

$(LIB_DEP_FILES): $(OBJECTS_DIR)
$(LIB_DEP_FILES): $(BUILD_FILE)
$(LIB_DEP_FILES): $(OBJECTS_DIR)/%.deps: %.c
	@echo "generating '$@'"
	@$(CC) $(lCFLAGS) $(lLIBS_CFLAGS) -MM -o $@ $*.c

$(DEPS_FILE): $(BUILD_FILE)
	@echo "generating dependencies: '$(DEPS_FILE)'"
	@touch $(DEPS_FILE)
	@makedepend -s "# generated dependencies" -f $(DEPS_FILE) -- $(lCFLAGS) -- $(SOURCES)
	@rm $(DEPS_FILE).bak

marshals: $(MARSHALS_HEADER) $(MARSHALS_BODY)
$(MARSHALS_HEADER): $(MARSHALS_LIST)
	@echo "generating marshals"
	@glib-genmarshal --prefix=$(MARSHALS_PREFIX) $(MARSHALS_LIST) --header >$(MARSHALS_HEADER)
$(MARSHALS_BODY): $(MARSHALS_LIST)
	@glib-genmarshal --prefix=$(MARSHALS_PREFIX) $(MARSHALS_LIST) --body >$(MARSHALS_BODY)

$(MO): $(PO_DIR)/%.mo: $(PO_DIR)/%.po
	@echo "formatting '$*.po'"
	@$(BIN_MSGFMT) $(PO_DIR)/$*.po -o $@

#gettext:
i18n:
	@$(BIN_XGETTEXT) $(foreach dir, $(DIRS) $(LIBS) $(LIBS)/$(OPTLIBS), -D $(dir)) \
		-p ./$(PO_DIR) --from-code=UTF-8 --no-wrap --omit-header -i -F \
		--copyright-holder="$(COPYRIGHT)" --keyword=_ --keyword=N_ \
		$(foreach file, $(SOURCES) $(HEADERS) $(LIBS_SOURCES) $(LIBS_HEADERS), $(shell basename $(file)))
	@mv -f $(PO_DIR)/messages.po $(PO_DIR)/$(TARGET).pot
# if we want new messages start with english equivalent instead of empty
# create a po to use for updating
#	@cd $(PO_DIR); msginit --input $(TARGET).pot --output en_US.po --no-translator \
#		--locale=en_US >/dev/null 2>/dev/null
#	@cd $(PO_DIR); for i in `ls *.po` ; do \
#		if [ "$$i" != "en_US.po" ] ; then \
#		echo "updating $$i" ; \
#		$(BIN_MSGMERGE) --update --backup=none $$i en_US.po ; \
#		$(BIN_MSGFMT) $$i -o `echo $$i | sed -e s/.po/.mo/` ; \
#		fi \
