## emelfm2 0.4.1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
-# $Id: Makefile 560 2007-07-24 12:46:09Z tpgww $
+# $Id: Makefile 879 2008-05-12 00:04:41Z tpgww $
 #
-# Copyright (C) 2003-2007 tooar <tooar@gmx.net>
+# Copyright (C) 2003-2008 tooar <tooar@gmx.net>
 #
 # This file is part of emelFM2.
 # emelFM2 is free software; you can redistribute it and/or modify it
@@ -36,15 +36,10 @@
 
 TARGET = emelfm2
 
-MARSHALS_PREFIX = e2_marshal
-MARSHALS_LIST = src/build/$(MARSHALS_PREFIX).list
-MARSHALS_HEADER = src/build/$(MARSHALS_PREFIX).h
-MARSHALS_BODY = src/build/$(MARSHALS_PREFIX).c
-
 API_DOC_DIR = docs/api
 
 # build info for build.h
-VERSION=0.3.5
+VERSION=0.4.1
 #this is effectively a sub-version, to manage config file upgrades while not changing the version
 RELEASE=
 #RELEASE=.1
@@ -74,6 +69,7 @@
 BASENAME1:=thumbs
 BASENAME2:=track
 BASENAME3:=acl
+BASENAME4:=vfs
 LIBS_XSOURCES=
 LIBS_XHEADERS=
 # when doing make install, make i18n etc don't want to have to supply optional plugin parameters
@@ -86,6 +82,9 @@
 ifeq ($(WITH_ACL),0)
 WITH_ACL:=$(shell test -f $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3).so && echo "1" || echo "0" 2>&1)
 endif
+ifeq ($(WITH_VFS),0)
+WITH_VFS:=$(shell test -f $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME4).so && echo "1" || echo "0" 2>&1)
+endif
 
 ifeq ($(WITH_THUMBS),1)
 LIBS_XSOURCES += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME1)*.c)
@@ -98,6 +97,9 @@
 ifeq ($(WITH_ACL),1)
 LIBS_XSOURCES += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3)*.c)
 LIBS_XHEADERS += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3)*.h)
+endif
+ifeq ($(WITH_VFS),1)
+LIBS_XSOURCES += $(wildcard $(LIBS)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME4)*.c)
 endif
 
 # object directories that have to be created
@@ -181,6 +183,9 @@
 ifeq ($(I18N), 1)
 lCFLAGS += -DENABLE_NLS
 endif
+
+# some code can be compiler-version-specific
+#GCCV=$(shell $(CC) -v 2>&1 | grep '^gcc version ' | sed 's/ (.*//; s/.* //')
 
 # set up flags
 # overflow protection with gcc4
@@ -191,15 +196,22 @@
 else
 lCFLAGS += $(shell pkg-config --cflags gtk+-2.0 gthread-2.0)
 endif
+ifeq ($(WITH_HAL),1)
+lCFLAGS += $(shell pkg-config --cflags dbus-1 dbus-glib-1 hal hal-storage)
+endif
+
+lLIBS_CFLAGS += -shared -fPIC -DPIC
 ifeq ($(WITH_THUMBS),1)
-lCFLAGS += $(shell pkg-config --cflags gimpthumb-2.0)
-endif
-#for gvfs development
+lLIBS_CFLAGS += $(shell pkg-config --cflags gimpthumb-2.0)
+endif
+#for vfs and gvfs plugin development
+ifeq ($(WITH_VFS),1)
+lLIBS_CFLAGS += $(shell pkg-config --cflags gio-2.0 gio-unix-2.0)
+else
 ifeq ($(WITH_GVFS),1)
-lCFLAGS += $(shell pkg-config --cflags gio-standalone)
-endif
-
-lLIBS_CFLAGS += -shared -fPIC -DPIC
+lLIBS_CFLAGS += $(shell pkg-config --cflags gio-2.0 gio-unix-2.0)
+endif
+endif
 
 lLDFLAGS = $(LDFLAGS)
 # -lrt needed for clock_gettime()
@@ -213,11 +225,22 @@
 ifeq ($(WITH_THUMBS),1)
 lLIBS += $(shell pkg-config --libs gimpthumb-2.0)
 endif
-ifeq ($(WITH_TRACKER),1)
-#	lLIBS += $(shell pkg-config --libs ??)
-endif
+#ifeq ($(WITH_TRACKER),1)
+#lLIBS += $(shell pkg-config --libs ??)
+#endif
 ifeq ($(WITH_ACL),1)
 lLIBS += -lacl
+endif
+ifeq ($(WITH_HAL),1)
+lLIBS += $(shell pkg-config --libs dbus-1 dbus-glib-1 hal hal-storage)
+endif
+# for vfs & gvfs development
+ifeq ($(WITH_VFS),1)
+lLIBS += $(shell pkg-config --libs gio-2.0 gio-unix-2.0)
+else
+ifeq ($(WITH_GVFS),1)
+lLIBS += $(shell pkg-config --libs gio-2.0 gio-unix-2.0)
+endif
 endif
 # should not need translation
 OPSYS := $(shell uname)
@@ -226,13 +249,8 @@
 lLIBS += $(shell if test $(OSREL) -lt 500041 ; then echo "-lgnugetopt"; fi)
 endif
 
-#for gvfs development
-ifeq ($(WITH_GVFS),1)
-lLIBS += $(shell pkg-config --libs gio-standalone)
-endif
-
 .PHONY: all plugins install install_plugins uninstall uninstall_plugins doc \
-        clean deps marshals gettext i18n install_i18n uninstall_i18n \
+        clean deps i18n install_i18n uninstall_i18n \
 		test test2 help
 
 # targets
@@ -254,15 +272,13 @@
 	done
 	@install -d $(MAN_DIR)
 	@install -m 644 docs/$(TARGET).1 $(MAN_DIR);
-	@bzip2 -f $(MAN_DIR)/$(TARGET).1;
+#	@bzip2 -f $(MAN_DIR)/$(TARGET).1;
 
 ifeq ($(XDG_INTEGRATION), 1)
-		@install -d $(XDG_DESKTOP_DIR)
-		@install -m 644 docs/desktop_environment/$(TARGET).desktop \
-			$(XDG_DESKTOP_DIR)
-		@install -d $(XDG_APPLICATION_DIR)
-		@install -m 644 docs/desktop_environment/$(TARGET).applications \
-			$(XDG_APPLICATION_DIR)
+	@install -d $(XDG_DESKTOP_DIR)
+	@install -m 644 docs/desktop_environment/$(TARGET).desktop $(XDG_DESKTOP_DIR)
+	@install -d $(XDG_APPLICATION_DIR)
+	@install -m 644 docs/desktop_environment/$(TARGET).applications $(XDG_APPLICATION_DIR)
 endif
 
 install_plugins: plugins
@@ -271,7 +287,7 @@
 	@for file in "$(LIBS_OBJECTS)"; do \
 		install -c -m 755 $$file $(PLUGINS_DIR); \
 	done
-	@for file in $$(ls -x $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)/*.so); do \
+	@for file in $$(ls -x $(OBJECTS_DIR)/$(LIBS)/$(OPTLIBS)/*.so 2>/dev/null); do \
 		install -c -m 755 $$file $(PLUGINS_DIR); \
 	done
 	@install -d $(ICON_DIR)
@@ -308,8 +324,6 @@
 	@echo "cleaning up"
 	@rm -f $(TARGET)
 	@rm -f $(BUILD_FILE)
-	@rm -f $(MARSHALS_BODY)
-	@rm -f $(MARSHALS_HEADER)
 	@rm -f *.bak
 	@rm -f $(PO_DIR)/*.mo
 	@rm -rfd $(OBJECTS_DIR)
@@ -349,13 +363,6 @@
 	@touch $(DEPS_FILE)
 	@makedepend -s "# generated dependencies" -f $(DEPS_FILE) -- $(lCFLAGS) -- $(SOURCES)
 	@rm $(DEPS_FILE).bak
-
-marshals: $(MARSHALS_HEADER) $(MARSHALS_BODY)
-$(MARSHALS_HEADER): $(MARSHALS_LIST)
-	@echo "generating marshals"
-	@glib-genmarshal --prefix=$(MARSHALS_PREFIX) $(MARSHALS_LIST) --header >$(MARSHALS_HEADER)
-$(MARSHALS_BODY): $(MARSHALS_LIST)
-	@glib-genmarshal --prefix=$(MARSHALS_PREFIX) $(MARSHALS_LIST) --body >$(MARSHALS_BODY)
 
 $(MO): $(PO_DIR)/%.mo: $(PO_DIR)/%.po
 	@echo "formatting '$*.po'"
@@ -371,10 +378,3 @@
 # if we want new messages start with english equivalent instead of empty
 # create a po to use for updating
 #	@cd $(PO_DIR); msginit --input $(TARGET).pot --output en_US.po --no-translator \
-#		--locale=en_US >/dev/null 2>/dev/null
-#	@cd $(PO_DIR); for i in `ls *.po` ; do \
-#		if [ "$$i" != "en_US.po" ] ; then \
-#		echo "updating $$i" ; \
-#		$(BIN_MSGMERGE) --update --backup=none $$i en_US.po ; \
-#		$(BIN_MSGFMT) $$i -o `echo $$i | sed -e s/.po/.mo/` ; \
-#		fi \
