## emelfm2 0.7.2

=== Makefile ===
# $Id: Makefile 2063 2010-03-03 11:54:07Z tpgww $
#
# Copyright (C) 2003-2009 tooar <tooar@emelfm2.net>
#
# This file is part of emelFM2.
# emelFM2 is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# emelFM2 is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with emelFM2; see the file GPL. If not, contact the Free Software
# Foundation, 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

# This is the Makefile of emelFM2. You should not change it!
# Edit the file Makefile.config to change build options.

# include user configuration
include Makefile.config

# internal configuration
DIRS=src src/actions src/build src/command src/command/complete src/config \
     src/dialogs src/filesystem src/utils
LIBS=plugins
OPTLIBS=plugins/optional
ICONS=icons
OBJECTS_DIR=objs
DOCS=docs
PO_DIR=po
API_DIR=docs/api

BUILD_FILE=src/build/build.h

# build info for build.h
VERSION=0.7.2
#this is effectively a sub-version, to manage config file upgrades while not changing the version
RELEASE=
#RELEASE=.1
PROGNAME=emelFM2
BUILDDATE=$(shell date)
BUILDSTAMP=$(shell date +"%02d %b %04Y")
BUILDINFO=$(shell uname) $(shell uname -r)/$(shell uname -m)
COPYRIGHT=2003-$(shell date +"%04Y"), tooar <tooar@emelfm2.net>

ifeq ($(DOCS_VERSION), 1)
# cannot use just +=, that inserts a space
TMP:=$(DOC_DIR)-$(VERSION)
DOC_DIR:=$(TMP)
endif

# object directories that have to be created
MKOBJDIRS = $(foreach dir, $(DIRS) $(LIBS) $(OPTLIBS), $(OBJECTS_DIR)/$(dir))

HEADERS = $(foreach dir, $(DIRS), $(wildcard $(dir)/*.h))
SOURCES = $(foreach dir, $(DIRS), $(wildcard $(dir)/*.c))
OBJECTS = $(SOURCES:%.c=$(OBJECTS_DIR)/%.o)
DEP_FILES = $(SOURCES:%.c=$(OBJECTS_DIR)/%.deps)

LIBS_HEADERS = $(foreach dir, $(LIBS), $(wildcard $(dir)/*.h))
LIBS_SOURCES = $(foreach dir, $(LIBS), $(wildcard $(dir)/*.c))
LIBS_OBJECTS = $(LIBS_SOURCES:%.c=$(OBJECTS_DIR)/%.so)
LIBS_DEP_FILES = $(LIBS_SOURCES:%.c=$(OBJECTS_DIR)/%.deps)

# optional plugins (and related icons, below)
PLUGFILEPREFIX=e2p_
ICONFILEPREFIX=plugin_
BASENAME1:=thumbs
BASENAME2:=track
BASENAME3:=acl
BASENAME4:=vfs

ifeq ($(WITH_THUMBS),0)
# when doing make install, make i18n etc don't want to have to supply optional plugin parameters
WITH_THUMBS:=$(shell test -f $(OBJECTS_DIR)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME1).so && echo "1" || echo "0" 2>&1)
endif
ifeq ($(WITH_THUMBS),1)
THUMBS_HEADERS = $(wildcard $(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME1)*.h)
THUMBS_SOURCES = $(wildcard $(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME1)*.c)
THUMBS_OBJECTS = $(THUMBS_SOURCES:%.c=$(OBJECTS_DIR)/%.so)
ifeq ($(STATIC_THUMBLIB),1)
THUMBS_FLAGS =
THUMBS_LIBS =
else
THUMBS_FLAGS = $(shell pkg-config --cflags gimpthumb-safe-2.0)
THUMBS_LIBS = $(shell pkg-config --libs gimpthumb-safe-2.0)
#THUMBS_FLAGS = $(shell pkg-config --cflags gimpthumb-2.0)
#THUMBS_LIBS = $(shell pkg-config --libs gimpthumb-2.0)
endif
endif

ifeq ($(WITH_ACL),0)
WITH_ACL:=$(shell test -f $(OBJECTS_DIR)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3).so && echo "1" || echo "0" 2>&1)
endif
ifeq ($(WITH_ACL),1)
ACL_HEADERS = $(wildcard $(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3)*.h)
ACL_SOURCES = $(wildcard $(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME3)*.c)
ACL_OBJECTS = $(ACL_SOURCES:%.c=$(OBJECTS_DIR)/%.so)
ACL_FLAGS =
ACL_LIBS = -lacl
endif

ifeq ($(WITH_TRACKER),0)
WITH_TRACKER:=$(shell test -f $(OBJECTS_DIR)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME2).so && echo "1" || echo "0" 2>&1)
endif
ifeq ($(WITH_TRACKER),1)
TRACKER_HEADERS = $(wildcard $(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME2)*.h)
TRACKER_SOURCES = $(wildcard $(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME2)*.c)
TRACKER_OBJECTS = $(TRACKER_SOURCES:%.c=$(OBJECTS_DIR)/%.so)
TRACKER_FLAGS = #$(shell pkg-config --cflags ??)
TRACKER_LIBS = #$(shell pkg-config --libs ??)
endif

ifeq ($(WITH_VFS),0)
WITH_VFS:=$(shell test -f $(OBJECTS_DIR)/$(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME4).so && echo "1" || echo "0" 2>&1)
endif
ifeq ($(WITH_VFS),1)
 VFS_HEADERS = $(wildcard $(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME4)*.h)
 VFS_SOURCES = $(wildcard $(OPTLIBS)/$(PLUGFILEPREFIX)$(BASENAME4)*.c)
 VFS_OBJECTS = $(VFS_SOURCES:%.c=$(OBJECTS_DIR)/%.so)
 VFS_FLAGS = $(shell pkg-config --cflags gio-2.0 gio-unix-2.0)
 VFS_LIBS = $(shell pkg-config --libs gio-2.0 gio-unix-2.0)
else
 ifeq ($(WITH_GVFS),1)
  VFS_HEADERS = #FIXME
  VFS_SOURCES = #FIXME
  VFS_OBJECTS = #FIXME
  VFS_FLAGS = $(shell pkg-config --cflags gio-2.0 gio-unix-2.0)
  VFS_LIBS = $(shell pkg-config --libs gio-2.0 gio-unix-2.0)
 endif
endif

LIBS_XHEADERS = $(THUMBS_HEADERS) $(ACL_HEADERS) $(TRACKER_HEADERS) $(VFS_HEADERS)
LIBS_XSOURCES = $(THUMBS_SOURCES) $(ACL_SOURCES) $(TRACKER_SOURCES) $(VFS_SOURCES)
LIBS_XOBJECTS = $(LIBS_XSOURCES:%.c=$(OBJECTS_DIR)/%.so)
LIBS_XDEP_FILES = $(LIBS_XSOURCES:%.c=$(OBJECTS_DIR)/%.deps)

# set up flags
lCFLAGS = $(CFLAGS)
ifeq ($(USE_LATEST), 1)
#these are redundant now
#lCFLAGS += -DGTK_DISABLE_DEPRECATED
#lCFLAGS += -DGDK_DISABLE_DEPRECATED
#lCFLAGS += -DG_DISABLE_DEPRECATED
#disable direct access to 'becoming-private' object-data
#lCFLAGS += -DGSEAL_ENABLE
endif

# set up debugging
ifeq ($(DEBUG), 0)
# this default level omits all warning-message code
DEBUG_LEVEL ?= 2
else
#this is the highest level
DEBUG_LEVEL ?= 5
lCFLAGS += -g -O0
endif

#gamin code is a superset of FAM code, so gamin needs fam as well
ifeq ($(USE_GAMIN), 1)
USE_FAM = 1
endif
#FAM & gamin prevail over specific kernel monitoring
ifeq ($(USE_FAM),1)
WITH_KERNELFAM = 0
USE_INOTIFY = 0
USE_DNOTIFY = 0
endif
ifeq ($(USE_DNOTIFY),1)
WITH_KERNELFAM = 1
USE_INOTIFY = 0
else
ifeq ($(WITH_KERNELFAM),1)
WITH_KERNELFAM = 1
USE_INOTIFY = 1
endif
endif

#other conditional defines set in $(BUILD_FILE) - see below

# set up i18n
BIN_XGETTEXT = $(shell which xgettext 2>/dev/null)
ifeq ($(BIN_XGETTEXT), "")
I18N = 0
endif
BIN_MSGFMT = $(shell which msgfmt 2>/dev/null)
ifeq ($(BIN_MSGFMT), "")
I18N = 0
endif
BIN_MSGMERGE = $(shell which msgmerge 2>/dev/null)
ifeq ($(BIN_MSGMERGE), "")
I18N = 0
endif
ifeq ($(I18N), 1)
PO_FILES=$(wildcard $(PO_DIR)/*.po)
MO_FILES=$(PO_FILES:%.po=%.mo)
lCFLAGS += -DENABLE_NLS
endif

# local include directories
LINC = $(foreach dir, $(DIRS), -I$(dir))
#LLIBINC = $(foreach dir, $(LIBS) $(OPTLIBS), -I$(dir))

# some code can be compiler-version-specific
#GCCV=$(shell $(CC) -v 2>&1 | grep '^gcc version ' | sed 's/ (.*//; s/.* //')

# overflow protection with gcc4
#lCFLAGS += -D_FORTIFY_SOURCE
lCFLAGS += -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_REENTRANT -I. $(LINC)
ifeq ($(EDITOR_SPELLCHECK),1)
lCFLAGS += $(shell pkg-config --cflags gtk+-2.0 gthread-2.0 gtkspell-2.0)
else
lCFLAGS += $(shell pkg-config --cflags gtk+-2.0 gthread-2.0)
endif
ifeq ($(WITH_DEVKIT),1)
lCFLAGS += $(shell pkg-config --cflags dbus-glib-1)
else
ifeq ($(WITH_HAL),1)
lCFLAGS += $(shell pkg-config --cflags dbus-1 dbus-glib-1 hal hal-storage)
endif
endif

lLIBS_CFLAGS = -shared -fPIC -DPIC

#setup linking
# -lrt needed for clock_gettime()
lLIBS = $(shell pkg-config --libs gtk+-2.0 gthread-2.0 gmodule-2.0) -lrt
ifeq ($(USE_FAM),1)
lLIBS += -lfam
endif
ifeq ($(EDITOR_SPELLCHECK),1)
lLIBS += -lgtkspell
endif
ifeq ($(WITH_DEVKIT),1)
lLIBS += $(shell pkg-config --libs dbus-glib-1)
else
ifeq ($(WITH_HAL),1)
lLIBS += $(shell pkg-config --libs dbus-1 dbus-glib-1 hal hal-storage)
endif
endif
# should not need translation
OPSYS := $(shell uname)
ifeq ($(OPSYS),FreeBSD)
OSREL = $(shell sysctl -n kern.osreldate)
lLIBS += $(shell if test $(OSREL) -lt 500041 ; then echo "-lgnugetopt"; fi)
endif

.PHONY: all plugins install install_plugins uninstall uninstall_plugins doc \
        clean clean_plugins deps i18n install_i18n uninstall_i18n \
        test test2 help

# targets
all: $(OBJECTS_DIR) $(BUILD_FILE) $(TARGET) $(LIBS) $(OPTLIBS)

plugins: $(OBJECTS_DIR)/$(LIBS) $(LIBS_OBJECTS) $(LIBS_XOBJECTS)

install: all install_plugins
	@echo "installing $(TARGET) to prefix '$(PREFIX)'"
	@install -d -m 755 $(BIN_DIR)
	@install -m 755 $(TARGET) $(BIN_DIR)
	@install -d $(ICON_DIR)
	@for file in `ls $(ICONS)/ |grep -v svn`; do \
		install -m 644 $(ICONS)/$$file $(ICON_DIR); \
	done
	@install -d $(DOC_DIR)
	@for file in `ls $(DOCS)/ |grep -v svn |grep -v desktop_environment |grep -v api |grep -v $(TARGET).1`; do \
		install -m 644 $(DOCS)/$$file $(DOC_DIR); \
	done
	@install -d $(MAN_DIR)
	@install -m 644 $(DOCS)/$(TARGET).1 $(MAN_DIR);
#	@bzip2 -f $(MAN_DIR)/$(TARGET).1;

	@if [ "`grep "#define E2_XDG" $(BUILD_FILE)`" = "#define E2_XDG" ]; then \
		install -d $(XDG_DESKTOP_DIR); \
		install -m 644 $(DOCS)/desktop_environment/$(TARGET).desktop $(XDG_DESKTOP_DIR); \
		install -d $(XDG_APPLICATION_DIR); \
		install -m 644 $(DOCS)/desktop_environment/$(TARGET).applications $(XDG_APPLICATION_DIR); \
	fi

# no i18n install unless specific target used

install_plugins: plugins
	@echo "installing plugins to prefix '$(PREFIX)'"
	@install -d $(PLUGINS_DIR)
	@for file in "$(LIBS_OBJECTS) $(LIBS_XOBJECTS)"; do \
		install -m 755 $$file $(PLUGINS_DIR); \
	done
	@install -d $(ICON_DIR)
#FIXME also handle svg icons etc
ifeq ($(WITH_THUMBS),1)
	@install -m 644 $(OPTLIBS)/$(ICONFILEPREFIX)$(BASENAME1)_48.png $(ICON_DIR);
endif
ifeq ($(WITH_TRACKER),1)
	@install -m 644 $(OPTLIBS)/$(ICONFILEPREFIX)$(BASENAME2)_48.png $(ICON_DIR);
endif
ifeq ($(WITH_ACL),1)
	@install -m 644 $(OPTLIBS)/$(ICONFILEPREFIX)$(BASENAME3)_48.png $(ICON_DIR);
endif

uninstall: uninstall_plugins
	@echo "uninstalling $(TARGET) from prefix '$(PREFIX)'"
	@rm -f $(BIN_DIR)/$(TARGET)
	@rm -rfd $(DOC_DIR)
#	@echo -e "\nif you like you can also delete the icon directory:\n\t$(ICON_DIR)\n"
	@rm -rfd $(ICON_DIR)
	@rm -f $(MAN_DIR)/$(TARGET).1*;

uninstall_plugins:
	@echo "uninstalling plugins from prefix '$(PREFIX)'"
# 2 removals in case the paths are different, divert any test failure with "|| cd ."
	@test -d "$(LIB_DIR)/$(TARGET)" && rm -rfd "$(LIB_DIR)/$(TARGET)" || cd .
	@test -d "$(PLUGINS_DIR)" && rm -rfd "$(PLUGINS_DIR)" || cd .

doc:
	@echo -n "generating api documentation in '$(API_DIR)'"
	@rm -rfd $(API_DIR)
	@doxygen >/dev/null
	@echo

clean:
	@echo "cleaning up"
	@rm -f $(TARGET)
	@rm -f $(BUILD_FILE)
	@rm -f *.bak
	@rm -f $(PO_DIR)/*.mo
	@rm -rfd $(OBJECTS_DIR)
	@rm -rfd $(API_DIR)

clean_plugins:
	@echo "cleaning up plugins"
	@rm -rfd $(OBJECTS_DIR)/$(LIBS)

$(TARGET): $(OBJECTS)
	@echo "linking binary '$(TARGET)'"
	@$(CC) $(LDFLAGS) $(OBJECTS) -o $(TARGET) -Wl,--as-needed $(lLIBS)
ifeq ($(STRIP), 1)
ifneq ($(DEBUG), 1)
	@echo "stripping binary '$(TARGET)'"
	@strip $(TARGET)
endif
endif

$(OBJECTS): $(OBJECTS_DIR)/%.o: %.c
	@echo "compiling '$*.c'"
	@$(CC) $(lCFLAGS) -c -o $@ $*.c

$(LIBS_OBJECTS): $(OBJECTS_DIR)/%.so: %.c
	@echo "compiling '$*.c'"
	@$(CC) $(lCFLAGS) $(lLIBS_CFLAGS) $(LDFLAGS) -o $@ $*.c
ifeq ($(STRIP), 1)
ifneq ($(DEBUG), 1)
	@strip -g $@
endif
endif

$(THUMBS_OBJECTS): $(OBJECTS_DIR)/%.so: %.c
	@echo "compiling '$*.c'"
	@$(CC) $(lCFLAGS) $(lLIBS_CFLAGS) $(THUMBS_FLAGS) $(LDFLAGS) -o $@ $*.c -Wl,--as-needed $(THUMBS_LIBS)
ifeq ($(STRIP), 1)
ifneq ($(DEBUG), 1)
	@strip -g $@
endif
endif

$(ACL_OBJECTS): $(OBJECTS_DIR)/%.so: %.c
	@echo "compiling '$*.c'"
	@$(CC) $(lCFLAGS) $(lLIBS_CFLAGS) $(ACL_FLAGS) $(LDFLAGS) -o $@ $*.c -Wl,--as-needed $(ACL_LIBS)
ifeq ($(STRIP), 1)
ifneq ($(DEBUG), 1)
	@strip -g $@
endif
endif

$(TRACKER_OBJECTS): $(OBJECTS_DIR)/%.so: %.c
	@echo "compiling '$*.c'"
	@$(CC) $(lCFLAGS) $(lLIBS_CFLAGS) $(TRACKER_FLAGS) $(LDFLAGS) -o $@ $*.c -Wl,--as-needed $(TRACKER_LIBS)
ifeq ($(STRIP), 1)
ifneq ($(DEBUG), 1)
	@strip -g $@
endif
endif

$(VFS_OBJECTS): $(OBJECTS_DIR)/%.so: %.c
	@echo "compiling '$*.c'"
