## emelfm2 0.9.1

=== debian/changelog ===
emelfm2 (0.9.1-1~mx15+1) mx; urgency=medium

  * Rebuild for MX 15.
  * Bump debhelper compat to 9.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 21 Mar 2018 12:13:59 -0700

emelfm2 (0.9.1-1~trusty~ppa1) trusty; urgency=low

  * New upstream release

 -- Liviu Andronic <landronimirc@gmail.com>  Sun, 29 Apr 2014 16:45:30 -0400

emelfm2 (0.9.0-1~precise~ppa1) precise; urgency=low

  * New upstream release

 -- Liviu Andronic <landronimirc@gmail.com>  Sun, 01 Sep 2013 16:45:30 -0400

emelfm2 (0.8.2-1~precise~ppa1) precise; urgency=low

  * New upstream release

 -- Liviu Andronic <landronimirc@gmail.com>  Fri, 21 Dec 2012 16:45:30 -0400

emelfm2 (0.8.1-1~precise~ppa1) precise; urgency=low

  * New upstream release

 -- Liviu Andronic <landronimirc@gmail.com>  Sun, 22 Apr 2012 16:45:30 -0400

emelfm2 (0.8.0-1~oneiric~ppa1) oneiric; urgency=low

  * Fix 'debian' rules and deps
  * Initial import

 -- Liviu Andronic <landronimirc@gmail.com>  Fri, 03 Feb 2012 16:45:30 -0400

emelfm2 (0.8.0-0ubuntu1~ppall1) lucid; urgency=low

  * New upstream release
  * added make parameter WITH_GTK2, which if set to 1 will ensure that gtk3 build-infrastructure is ignored
  * more gtk3 workarounds

 -- Nick Bryda <nickbryda@gmx.us>  Tue, 09 Aug 2011 16:45:30 -0400

emelfm2 (0.7.5-0ubuntu1~ppall1) lucid; urgency=low

  * New upstream release
  * make debian-unofficial stuff work again (i.e. after renaming the dir to debian)
  * remove dnotify support (still in offcuts, if someone wants it, something can be worked out)
  * improve usability of glob plugin including select _additional_ items if <Ctrl> pressed when proceeding
  * revamp auto-refresh mechanisms
  * udisks/devicekit-disks support (WITH_DEVKIT=1) uses glib API instead of libdbus-glib, for glib >= 2.26
  * bugfixes
  * support opening dirs with '&' in name
  * fix crash after entering a non-existent dir into a dirline
  * fix random crash when setting up dialogs
  * fix detection of tracker daemon in find plugin
  * fix hang sometimes when opening thumbnails plugin

 -- Nick Bryda <nickbryda@gmx.us>  Sun, 20 Feb 2011 22:50:42 -0500

emelfm2 (0.7.4-0ubuntu1~ppall) lucid; urgency=low

  * New upstream release
  * change Makefile default STATIC_THUMBLIB ?= 1 to WITH_THUMBLIB ?= 0
  * change thumbnails plugin to optionally work with renamed library 'libthumbs', available from website OtherDownloads?
  * support argument for file.du action, to specify file name/pattern instead of selected items
  * for gtk >= 2.20, show GtkSpinner? in status bar when file operation is in progress
  * refine history-menu creation (no duplicates etc), operation (activation during hover), and cacheing (limited no. of dirs)
  * revised inotify backend for file-alteration-monitoring
  * conform to gtk 3.0 API where relevant
  * bugfixes
    - when using HAL/devkit/udisks, don't display a filelist on an unmounted device
    - revised operation of pane.<bookmarks> action
    - block emission of "activate" signals after combo change in ownership dialog
    - fix crash when cd's repeated rapidly
    - fix bad setup of mkdir dialog for some users
    - fix setting group in ownership dialog for gtk >= 2.14

 -- Nick Bryda <nickbryda@gmx.us>  Sat, 04 Dec 2010 15:34:42 -0500

emelfm2 (0.7.3-0ubuntu1~ppall1) lucid; urgency=low

  * New upstream release
  * pack and unpack plugins support tar.xz archives
  * printing supports page-selection options of gtk's print-dialog
  * file info dialog for a directory reports count and usage of contained items
  * updated translations (except ru)
  * conform pack-plugin button label
  * fix crash in config plugin
  * fix crash when entering just "/" in a dirline
  * fix (again) processing of dirs named like "X ~ Y"
  * block status-bar updates during filelist updates, and vice versa

 -- Nick Bryda <nickbryda@gmx.us>  Wed, 14 Jul 2010 15:48:06 -0400

emelfm2 (0.7.2-0ubuntu1~ppall1) lucid; urgency=low

  * Build for Lucid

 -- Nick Bryda <nickbryda@gmx.us>  Tue, 13 Apr 2010 12:00:38 -0400

emelfm2 (0.7.2-0ubuntu1~ppakk1) karmic; urgency=low

  * reinstated cacheing of session forward/back histories, optional and enabled by default
  * added action pane.clear_history which clears either or both forward/back histories
  * added to default filelist-context-menu a sub-menu showing the pane's entire forward/back history
  * if built with E2_DEVKIT, it will work with UDisks if available, or else with DeviceKit?-Disks if available
  * select-same plugin scrolls to show 1st selected, if any
  * select-same plugin has a 2nd action, enabling partial matching e.g. 'pre-extension', with some related config options
  * find plugin tab-labels show colored text when any content of the tab is non-default
  * updated translations
  * bugfixes
    - eliminate some incorrect mismatches by comparer plugin

 -- Nick Bryda <nickbryda@gmx.us>  Thu, 11 Mar 2010 21:31:15 -0500

emelfm2 (0.7.1-0ubuntu1~ppakk1) karmic; urgency=low

  * New upstream release
  * don't always add activated-dirline content to the corresponding history
  * added action dirline.clear_history which removes current dirline string from the corresponding combo history
  * bugfixes
  * fix build with ASSIST
  * fix session-start divider positioning with horizontal panes on gtk 2.18
  * fix crash when closing a tree-dialog that's not yet populated
  * fix crash when attempting to open nested inaccessible dir
  * don't always recurse when changing owner/group

 -- Nick Bryda <nickbryda@gmx.us>  Tue, 29 Dec 2009 16:04:41 -0500

emelfm2 (0.7.0-0ubuntu1~ppakk1) karmic; urgency=low

  * New upstream release
  * by default, build relevant parts of customised libgimpthumb directly into thumbnails plugin
  * automatically send commands containing "&&" to external shell
  * pop up corresponding history menu when pointer hovers over toolbar go-forward or go-back button
  * updated translations
  * bugfixes
    - several data-dependant dialogs close, instead of crash, when main-window is rebuilt


