=== debian/control ===
Source: emelfm2
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Liviu Andronic <landronimirc@gmail.com>
# XSBC-Original-Maintainer: Ralf Meyer <ranfyy@gmail.com>
Build-Depends: libglib2.0-dev,
               libgtk2.0-dev (>= 2.6),
               imagemagick,
               debhelper (>= 9),
               quilt (>= 0.46-7~),
               libmagic-dev,
               libgtkspell-dev (>= 2.0.14),
               libdbus-glib-1-dev,
               libacl1-dev
Standards-Version: 3.9.7
Homepage: http://emelfm2.net

Package: emelfm2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmagic1
Recommends: libbz2-1.0, liblzo2-2,
            grep (>= 2.5.3), sed (>= 4.1.5), udisks, policykit-1
Suggests: tracker-utils
Description: file manager for X/gtk
 emelFM2 is a file manager that implements the popular two-pane
 design. It features a simple GTK+2 interface, a flexible file
 typing scheme, and a built-in command line for executing commands
 without opening an external terminal.
