=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
#export DH_OPTIONS=-v

# Default CFLAGS are specified in package file Makefile.config.
# Any override must be passed to make as CFLAGS=<whatever> in MAKEOPTS
MAKEOPTS = \
 WITH_KERNELFAM=1 \
 NEW_COMMAND=1 \
 EDITOR_SPELLCHECK=1 \
 WITH_LATEST=1 \
 WITH_GTK2=1 \
 WITH_THUMBS=1 WITH_THUMBLIB=0 \
 WITH_TRACKER=1 \
 WITH_ACL=1 \
 WITH_POLKIT=1 \
 WITH_UDISKS=1 \
 WITH_OUTPUTSTYLES=1

# alternate for WITH_UDISKS :: WITH_HAL=1

#CFLAGS = -Wall -g

#ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
#	CFLAGS += -O0
#else
#	CFLAGS += -O2
#endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp


build:  build-stamp

build-stamp: configure-stamp 
	dh_testdir

	$(MAKE) PREFIX=/usr $(MAKEOPTS)
	convert icons/emelfm2_32.png debian/emelfm2.xpm

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	$(RM) po/emelfm2.pot
	$(RM) debian/emelfm2.xpm

	[ ! -f Makefile ] || $(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean
	dh_installdirs

	$(RM) docs/INSTALL docs/GPL docs/LGPL
	$(MAKE) install PREFIX=$(CURDIR)/debian/emelfm2/usr/
	$(MAKE) install_i18n PREFIX=$(CURDIR)/debian/emelfm2/usr/
	cp -r $(CURDIR)/icons/* $(CURDIR)/debian/emelfm2/usr/share/pixmaps/emelfm2/
	cp $(CURDIR)/debian/*.xpm $(CURDIR)/debian/emelfm2/usr/share/pixmaps/emelfm2/
	ln -s emelfm2/emelfm2_48.png $(CURDIR)/debian/emelfm2/usr/share/pixmaps/emelfm2.png
	#cp $(CURDIR)/docs/USAGE $(CURDIR)/docs/CONFIGURATION $(CURDIR)/debian/emelfm2/usr/share/doc/emelfm2

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installmenu
	dh_installman
	dh_strip
	#dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
