=== debian/watch ===
# You can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

version=3

http://emelfm2.net/rel/emelfm2-(.*)\.tar\.gz \
    debian \
    uupdate
